# インボイス 取得

`GET /v1/invoices/{id}`

- operationId: `getInvoices`
- tags: インボイス機能

指定したIDを持つインボイス情報を取得します。


## コードサンプル

### cURL

```bash
curl \
    -X GET \
    -H "Authorization:Bearer <Secret API Key>" \
'https://api.test.fincode.jp/v1/invoices/{id}'
```

### Node.js

```javascript
import fetch from "node-fetch";

const BASE_URL = "https://api.test.fincode.jp";
const API_KEY = "<Secret API Key>";

(async () => {
    const invoiceId = "<Invoice ID>"; // 実際のインボイスIDを入力してください

    const endpoint = `${BASE_URL}/v1/invoices/${invoiceId}`;

    try {
        const response = await fetch(endpoint, {
            method: "GET",
            headers: {
                Authorization: `Bearer ${API_KEY}`,
            },
        });

        if (!response.ok) {
            throw new Error(`Error: ${response.statusText}`);
        }

        const invoice = await response.json();
        console.log(invoice); // 取得したインボイスデータをコンソールに表示
    } catch (error) {
        console.error('Error:', error);
    }
})();
```

### Go

```go
package main

import (
	"fmt"
	"io"
	"log"
	"net/http"
)

func main() {
	apiKey := "<Secret API Key>"
	invoiceID := "<Invoice ID>"

	// リクエストの作成
	req, err := http.NewRequest(
		"GET",
		fmt.Sprintf("https://api.test.fincode.jp/v1/invoices/%s", invoiceID),
		nil,
	)
	if err != nil {
		log.Fatalf("リクエストの作成エラー: %v", err)
	}

	// ヘッダーの設定
	req.Header.Set("Authorization", fmt.Sprintf("Bearer %s", apiKey))

	// リクエストの送信
	client := &http.Client{}
	res, err := client.Do(req)
	if err != nil {
		log.Fatalf("リクエストエラー: %v", err)
	}
	defer res.Body.Close()

	// HTTPステータスコードを表示
	fmt.Println("HTTPステータスコード:", res.StatusCode)

	// レスポンスボディを読み取って表示
	body, err := io.ReadAll(res.Body)
	if err != nil {
		log.Fatalf("レスポンスボディの読み取りエラー: %v", err)
	}
	fmt.Println("レスポンスボディ:", string(body))
}
```

### PHP

```php
<?php

$apiKey = '<Secret API Key>';

$invoiceId = '<Invoice ID>';

$baseUrl = "https://api.test.fincode.jp";
$endpoint = "/v1/invoices/{$invoiceId}";
$queryParams = [
    // 必要なクエリパラメータがあればここに追加
    // "example_param" => "value",
];

$headers = [
    "Authorization: Bearer " . $apiKey,
];

$session = curl_init();
curl_setopt($session, CURLOPT_URL, $baseUrl . $endpoint . '?' . http_build_query($queryParams));
curl_setopt($session, CURLOPT_HTTPHEADER, $headers);
curl_setopt($session, CURLOPT_HTTPGET, true);
curl_setopt($session, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($session);

if ($response === false) {
    // エラー処理
    echo "cURL Error: " . curl_error($session);
} else {
    // APIからのデータを処理
    $responseData = json_decode($response, true);
    if (json_last_error() === JSON_ERROR_NONE) {
        // JSONが正しく解析された場合
        var_dump($responseData);
    } else {
        // JSON解析エラー
        echo "JSON Decode Error: " . json_last_error_msg();
    }
}

curl_close($session);
```

### Python 3

```python
import requests

api_key = '<Secret API Key>'
invoice_id = '<Invoice ID>'

url = f'https://api.test.fincode.jp/v1/invoices/{invoice_id}'

# ヘッダーを設定
headers = {
    'Authorization': f'Bearer {api_key}',
}

try:
    response = requests.get(url, headers=headers)

    # レスポンスの処理
    if response.status_code == 200:
        # APIからのデータを処理
        print(f"Success: {response.json()}")
    else:
        # エラーの処理
        print(f"Error: {response.json()}")
except requests.RequestException as e:
    # 通信エラーの処理
    print(f"Request error: {e}")
```

### Ruby

```ruby
require 'net/http'
require 'uri'
require 'json'

API_KEY = '<Secret API Key>'
BASE_URL = 'https://api.test.fincode.jp'

def main
    invoice_id = '<Invoice ID>'

    endpoint = "/v1/invoices/#{invoice_id}"
    
    uri = URI.parse(BASE_URL + endpoint)

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true

    # リクエストの作成
    request = Net::HTTP::Get.new(uri.request_uri)
    request['Authorization'] = "Bearer #{API_KEY}"

    # リクエストの送信
    response = http.request(request)

    case response
    when Net::HTTPSuccess
        puts 'SUCCESS'
    else
        puts 'ERROR'
    end

    # レスポンスの表示
    puts JSON.pretty_generate(JSON.parse(response.body))
end

main
```

## パラメータ

| 名前 | 位置 | 必須 | 型 | 説明 |
| --- | --- | --- | --- | --- |
| `id` | path | ✓ | string | インボイスID |
| `Tenant-Shop-Id` | header |  | schema | <span class="smallText color--red-400">※ プラットフォームのメインショップのみ指定可</span> |

## レスポンス

### 200 リクエストに成功

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `id` | string |  | インボイスID |
| `status` | string |  | インボイス請求書のステータス |
| `invoice_url` | string |  | インボイス 請求ページURL |
| `bill_mail_send_flag` | enum(0 | 1) |  | 請求書メール送信フラグ (0: メールを送信しない 1: メールを送信する) |
| `bill_pdf_url` | string |  | [非推奨] インボイス請求書PDFダウンロードURL |
| `receipt_mail_send_flag` | enum(0 | 1) |  | 領収書メール送信フラグ (0: メールを送信しない 1: メールを送信する) |
| `underpayment_mail_send_flag` | enum(0 | 1) |  | 差額請求メール送信フラグ (0: メールを送信しない 1: メールを送信する) |
| `receipt_pdf_url` | string |  | [非推奨] インボイス領収書PDFダウンロードURL |
| `invoice_number` | string |  | 請求番号 |
| `customer_id` | string |  | 顧客（請求先）ID |
| `customer_honorific` | string |  | 顧客（請求先）敬称 |
| `customer` | object |  | 顧客（請求先）情報 |
| `customer_overwrite` | object |  | 上書き顧客（請求先）情報 |
| `issuer` | object |  | 発行元事業者情報 |
| `issuer_overwrite` | object |  | 上書き発行元事業者情報 |
| `issue_date` | string |  | 発行年月日 |
| `lines` | array<object> |  | 取引内容レコード |
| `total_amount` | number |  | 合計金額 |
| `billing_total_amount` | number |  | 請求金額合計 |
| `pay_types` | array<string> |  | 利用可能な決済種別リスト |
| `input_type` | enum(amount) |  | 取引金額の入力方式 |
| `card` | object |  | カード決済情報 |
| `virtual_account` | object |  | 銀行振込（バーチャル口座）情報 |
| `embedded_virtual_account` | object |  | このインボイス情報に対して発行されたバーチャル口座情報 |
| `is_tax_included` | boolean |  | 内税表記有無 |
| `due_date` | string |  | 支払期日 |
| `memo` | string |  | 備考 |
| `client_field_1` | string |  | 加盟店自由項目1 |
| `client_field_2` | string |  | 加盟店自由項目2 |
| `client_field_3` | string |  | 加盟店自由項目3 |
| `is_uncollectible` | boolean |  | 回収困難フラグ |
| `is_paid_externally` | boolean |  | fincode外支払フラグ |
| `transaction_date` | string |  | 支払完了日 |
| `bill_id` | string |  | 請求ID |
| `directdebit` | object |  | 口座振替情報 |
| `embedded_directdebit` | object |  | このインボイス情報に対する口座振替の口座情報 この口座から引き落とし完了することでインボイスによる請求に対して支払いできます。 |
| `invoice_backfill` | object |  | 後付け請求情報 |
| `created` | string |  | 作成日時 |
| `updated` | string |  | 更新日時 |
| `company_stamp_data` | string |  | 社印データをBase64エンコードした文字列 |

### 400 不正なリクエスト

| パラメータ | 型 | 必須 | 説明 |
| --- | --- | --- | --- |
| `errors` | array<FincodeAPIError> |  |  |

